// Copyright (c) Microsoft Open Technologies, Inc.  All rights reserved.  
// Licensed under the BSD 2-Clause License.  
// See License.txt in the project root for license information.

#ifndef _GPIO_INTERRUPT_H_
#define _GPIO_INTERRUPT_H_

#include "common.h"
#include <functional>

#include "DMap.h"

/// Class used to control and receive GPIO interrupts.
class GpioInterruptsClass
{
public:
	/// Constructor.
	GpioInterruptsClass()
	{
	}

	/// Destructor.
	virtual ~GpioInterruptsClass()
	{
	}

	/// Method to attach to an interrupt on a GPIO port bit.
	HRESULT attachInterrupt(ULONG pin, std::function<void(void)> func, ULONG mode, HANDLE hController);

	/// Method to detach an interrupt for a GPIO port bit.
	HRESULT detachInterrupt(ULONG pin, HANDLE hController);

private:

	std::future<void> _future;
};

#endif  // _GPIO_INTERRUPT_H_
